#include <Servo.h>

#define LINE_SENSOR(n) n+2
#define PARK_SENSOR_R 12
#define PARK_SENSOR_L 14

Servo LeftServo;  
Servo RightServo;
int FAST = 90; 
int SLOW = 5; 
int distSensor = 4;

int surX = 2;
int surY = 1;
char smer = 'U'; // U = up, L = left, R = Right, D = down

int pocPlech = 0;
int parkovisko = 2;

byte  EN_pin = 15;
byte CLK_pin = 16;
byte DIO_pin = 17;

long startTime = millis();

int sviet = 1;
int sever = 0;

int taktika = 1;

void setup() {
  LeftServo.attach(9);
  RightServo.attach(10);
  pinMode(13,OUTPUT);
  leftMotor(0);
  rightMotor(0);
  pinMode(EN_pin, OUTPUT);
  pinMode(CLK_pin, OUTPUT);
  pinMode(DIO_pin, INPUT);

  HM55B_Reset();
  Serial.begin(9600);
  Serial.println("Test started   \n");

}

void loop() {
  nastavSever();
  taktika1(1);
}

void nastavSever() {
  compass();
  for (int j = 0; j < 5; j++)
    sever += compass();
  sever /= 5;
}

int naSever(){
  int result = compass();
  result -= sever;
  if (result > 345) result -= 360;
  if (result < -345) result += 360;
  if (result < 1) result *= -1;
  result = result < 10;
  return result;
}

void taktika1(int kroky) {
  taktika = 1;
  if (kroky) {
    prvyKrok();
    if (surX == 1) {
      druhyKrokA();
    } 
    else {
      druhyKrokB();
    }
  } 
  while (1) {
    zaskodnic();
  }  
}

void straz() {  
  chodNa(2,2);
  chodNa(parkovisko, 1);
  prejdiKrizovatku();
  zaparkujBezOtocky();   
  stoj();
  while (1) ;
}

void prvyKrok() {
  int skorSkonci = 0;
  chodNa(2,1);  
  if (pocPlech == 1) {
    skorSkonci = 1;
  }
  chodNa(2,2);
  chodNa(1,2);
  pocPlech = 0;
  chodNa(1,1);  
  if (!skorSkonci && pocPlech == 1) {
    skorSkonci = 1;
  }
  if (skorSkonci) {
    prejdiKrizovatku();
    if (taktika == 3 && pocPlech)
      zaparkujBezOtocky();
    else
      zaparkuj();
  }
  else {
    chodNa(3,1);
    odbocVpravo();
    if (taktika == 3 && pocPlech)
      zaparkujBezOtocky();
    else
      zaparkuj();
  }
}

void druhyKrokA() {
  chodNa(1,3);
  pocPlech = 0;
  chodNa(3,3);
  if (pocPlech) {
    chodNa(3,1);
    prejdiKrizovatku();
    zaparkuj();
  } 
  else {
    chodNa(3,2);
    if (pocPlech) {
      chodNa(3,1);
      prejdiKrizovatku();      
      zaparkuj();
    }
    else {
      zaskodnic();
    }
  }
}

void odvezDomov(){
  if (pocPlech) {
    chodNa(parkovisko,2);
    chodNa(parkovisko, 1);
    prejdiKrizovatku();   
    switch (parkovisko) {
    case 1:
      parkovisko = 2;
      break;
    case 2:
      parkovisko = 3;
      break;        
    case 3:
      parkovisko = 1;
      break;            
    }
    if  (taktika == 3) zaparkujBezOtocky();
    zaparkuj();
  } 
  else {
    otocenie();
  }
}

void zaskodnic() {
  if (surX == 0 && surY == 4 && smer == 'L')
    otocenie();
  else
    lavyHornyRoh();
  pocPlech = 0;    
  while (!pocPlech) {
    chodNa(4,4);
    odvezDomov();
    chodNa(0,4);
    odvezDomov(); 
  }
}

void zaskodnic2() {
  pocPlech = 0;
  if (surX == 0 && surY == 4 && smer == 'L')
    otocenie();
  else
    lavyHornyRoh();
  while (!pocPlech && timeEllapsed() < 120000) {
    chodNa(4,4);
    odvezDomov();
    chodNa(0,4);
    odvezDomov(); 
  }  
}

void druhyKrokB() {
  pocPlech = 0;
  chodNa(3,2);
  int maPlech = pocPlech != 0;
  chodNa(2,3);
  pocPlech = 0;
  chodNa(1,3);
  maPlech |= pocPlech != 0;
  if (maPlech){
    chodNa(1,1);
    prejdiKrizovatku();
    zaparkuj();
  } 
  else {    
    zaskodnic();
  }
}

void lavyHornyRoh() {
  chodNa(0,3);  
  chodNa(0,4);
}

void zaparkuj() {
  pinMode(13,INPUT);
  while (!digitalRead(PARK_SENSOR_R) && !digitalRead(PARK_SENSOR_L)) {
    chodRovno();
  }
  otocenie();
}

void zaparkujBezOtocky() {
  pinMode(14,INPUT);
  while (!digitalRead(PARK_SENSOR_R) && !digitalRead(PARK_SENSOR_L)) {
    chodRovno();
  }
  stoj();
  while (1) ;
}  

void zasviet() {  
  pinMode(13,OUTPUT);
  if (sviet) {
    digitalWrite(13, HIGH);
    sviet = 0;
  } 
  else {
    digitalWrite(13, LOW);
    sviet = 1;
  }
}

void otocenie() {    
  zmenSmer();
  zvysSuradnicu();
  leftMotor(-FAST);
  rightMotor(-FAST);  
  delay(600);
  leftMotor(FAST);
  delay(1100);
}

long timeEllapsed() {  
  return millis() - startTime;
}

void printTimeEllapsed() {
  Serial.print("Time Ellapsed = ");
  Serial.print(timeEllapsed());
  Serial.println();
}

void zmenSmer() {
  switch (smer) {
  case 'U': 
    smer = 'D';    
    break;
  case 'D': 
    smer = 'U';    
    break;
  case 'R': 
    smer = 'L';    
    break;
  case 'L': 
    smer = 'R';
    break;      
  }
}


void vypisSurSmer() {
  Serial.print("Smer: ");
  Serial.print(smer);
  Serial.print(" X: ");
  Serial.print(surX);  
  Serial.print(" Y: ");
  Serial.print(surY);  
  Serial.println("");
}

int blizko() {
  int result = 1;
  for (int i = 0; i < 10; i++){ 
    result &= analogRead(distSensor) > 600;
    delay(1);
  }
  return result;
}

int black(long i) {  
  return digitalRead(LINE_SENSOR(i));
}

void leftMotor(int n) {
  LeftServo.write(90+n); 
}

void rightMotor(int n) {
  RightServo.write(90-n);
}


void hladajKrizovatku() {
  while (!krizovatka() && !blizko()) {
    chodRovno();
    delay(5);
  }
  if (blizko()){
    pocPlech++;  
    zasviet();
    hladajKrizovatkuCezMrtvoly();   
  };
}

void hladajKrizovatkuCezMrtvoly() {
  while (!krizovatka()) {
    chodRovno();
    delay(5);
  }
}

void zvysSuradnicu(){
  switch (smer) {
  case 'U': 
    ++surY; 
    break;
  case 'L':
    --surX;
    break;
  case 'R':
    ++surX;
    break;
  case 'D': 
    --surY;
    break;
  default:
    Serial.println("Weird character");        
  } 
}

void stoj() {
  leftMotor(0);
  rightMotor(0);
}

void odbocVpravo() {

  switch (smer) {
  case 'U': 
    smer = 'R';
    break;
  case 'R': 
    smer = 'D';
    break;            
  case 'D': 
    smer = 'L';
    break;
  case 'L': 
    smer = 'U';
    break;   
  default:
    Serial.println("Weird character");         
  }
  zvysSuradnicu();
  leftMotor(FAST);
  rightMotor(FAST);
  delay(200); 
  rightMotor(-FAST);
  leftMotor(FAST);
  delay(600);
  leftMotor(FAST);
  rightMotor(FAST);
  delay(200);
}

void odbocVlavo() {  
  switch (smer) {
  case 'U': 
    smer = 'L';
    break;
  case 'L': 
    smer = 'D';
    break;            
  case 'D': 
    smer = 'R';
    break;
  case 'R': 
    smer = 'U';
    break;   
  default:
    Serial.println("Weird character");         
  }
  zvysSuradnicu();
  leftMotor(FAST);
  rightMotor(FAST);
  delay(200); 
  rightMotor(FAST);
  leftMotor(-FAST);
  delay(600);
  leftMotor(FAST);
  rightMotor(FAST);
  delay(200); 
}

void prejdiKrizovatku(){
  zvysSuradnicu();
  leftMotor(FAST);
  rightMotor(FAST);
  delay(200);
}

int okraj(){
  int x = surX == 0 || surX == 4;
  int y = surY == 0 || surY == 4;
  return x && y;
}

int krizovatka() {
  int result = 0;
  for (int i = 0; i < 8; i++) {
    result += black(i);
  }
  return result >= 4; 
}

int strateny() {
  int result = 1;
  //  int result2 = 1;
  //  for (int i = 0; i < 1; i++) {
  //    delay(5);
  for (int j = 0; j < 8; j++) {
    result &= !black(j);          
  }       
  //    result2 &= result;
  //  }  

  //  return result2;
  return result;
}

int najdeny() { 

  int result = 0;
  for (int j = 0; j < 8; j++) {
    result += black(j);
  }         
  return result >= 2;

}

int vpreduVolne() {
  leftMotor(FAST);
  rightMotor(FAST);
  delay(300);
  if (strateny()) {
    leftMotor(-FAST);
    rightMotor(-FAST);
    delay(400);    
    return 0;
  } 
  else {
    return 1;
  }
}

int hladajRovno(){
  leftMotor(FAST);
  rightMotor(FAST);
  int i = 0;
  int ending = !najdeny();
  while (ending && i < 10){
    delay(100); 
    i++;
    ending = !najdeny();
    Serial.println(ending);
  }
  return !ending;
}

int najdiCiaru() {   
  if (hladajRovno()) {
    return 1;
  }
  else {
    otocenie();
    if (hladajRovno()){
      return 1;
    }
    if (hladajRovno()){
      return 1;
    }
    else {
      otocenie();
      if (hladajRovno()){
        return 1;
      }
      odbocVlavo();
      if (hladajRovno()){
        return 1;
      } 
      else {
        otocenie();
        if (hladajRovno()){
          return 1;
        }
        if (hladajRovno()){
          return 1;
        }
        else return 0;
      }
    }
  }  
}

//int najdiPomKrizovatku() {
//  while (!krizovatka()) {    
//    najdiCiaru();
//    odbocVlavo();
//    if (!vpreduVolne()) {
//      hladajKrizovatku();
//    }
//  }
//  return 1;
//}

void najdiSever(){
  leftMotor(SLOW);
  rightMotor(-SLOW);
  while (!naSever());
}

void odbocPokojneVlavo() {
  leftMotor(FAST);
  rightMotor(FAST);
  delay(100);  
  leftMotor(-FAST);
  delay(500);
}

void najdiSa() {
  najdiCiaru();
  hladajKrizovatku();
  prejdiKrizovatku();
  while (!naSever()){
    najdiSever();
    while (strateny()){
      leftMotor(-FAST);
      rightMotor(-FAST);
      delay(100);  
    }
  }
  hladajKrizovatku();
  while (vpreduVolne()){
    hladajKrizovatku();
    if (vpreduVolne())
      prejdiKrizovatku();
  }
  surY = 4;
  stoj();
  odbocPokojneVlavo();
  smer = 'L';
  while (strateny()){
    leftMotor(-FAST);
    rightMotor(-FAST);
    delay(100);
  }
  hladajKrizovatku();  
  while (vpreduVolne()){
    hladajKrizovatku();
    if (vpreduVolne())
      prejdiKrizovatku();
  }
  smer = 'L';  
  surX = 0;
  while (1)  {
    switch (taktika) {
    case 1: 
      taktika1(0);
      break;
    case 2: 
      taktika2(0);
      break;
    case 3: 
      taktika3(0);
      break;        
    }
  }
}

void chodRovno() {
  if (strateny()) {
    najdiSa();
  }
  int left = FAST, right = FAST;
  if (odchylkaVlavo()) {
    right = 0;
  }
  else if (odchylkaVpravo()) {
    left = 0;
  }
  leftMotor(left);
  rightMotor(right);
}

int okrajVlavo(){
  int a = smer == 'U' && surX == 0;
  int b = smer == 'D' && surX == 4;
  int c = smer == 'L' && surY ==  0;
  int d = smer == 'R' && surY == 4;
  return a || b || c || d;
}

int okrajVpravo(){
  int a = smer == 'U' && surX == 4;
  int b = smer == 'D' && surX == 0;
  int c = smer == 'L' && surY == 4;
  int d = smer == 'R' && surY == 0;
  return a || b || c || d;
}

int odchylkaVpravo() {
  int result = 0;
  if (okrajVpravo()) result |= black(4);
  if (!okrajVpravo()) result |= black(5);
  result |= black(6);
  result |= black(7);
  return result;
}

int odchylkaVlavo() {
  int result = 0;
  if (okrajVlavo()) result |= black(3);
  result |= black(0);
  result |= black(1);
  if (!okrajVlavo()) result |= black(2);
  return result;
}

void otocSpravne(){
  if (smer == 'U' && surX == 0) odbocVpravo();
  else if (smer == 'D' && surX == 4) odbocVpravo();
  else if (smer == 'L' && surY == 0) odbocVpravo();
  else if (smer == 'R' && surY == 4) odbocVpravo();
  else odbocVlavo();
}

void chodNa(int x, int y) {
  hladajKrizovatku();
  if (x == surX && y == surY) return;  
  switch (smer) {
  case 'U':
    while (y > surY) {
      prejdiKrizovatku();
      hladajKrizovatku();
      chodNa(x,y);
    } 
    if (x < surX){
      odbocVlavo();
      chodNa(x,y); 
    } 
    else if (x > surX) {
      odbocVpravo();
      chodNa(x,y); 
    }
    if (x == surX && y != surY) {
      otocSpravne();
      chodNa(x,y);
    }
    break; 
  case 'D':
    while (y < surY) {
      prejdiKrizovatku();
      hladajKrizovatku();
    } 
    if (x > surX){
      odbocVlavo();
      chodNa(x,y); 
    } 
    else if (x < surX) {
      odbocVpravo();
      chodNa(x,y); 
    } 
    if (x == surX && y != surY) {
      otocSpravne();
      chodNa(x,y);
    }
    break; 
  case 'R':
    while (x > surX) {
      prejdiKrizovatku();
      hladajKrizovatku();
    } 
    if (y > surY){
      odbocVlavo();
      chodNa(x,y); 
    } 
    else if (y < surY) {
      odbocVpravo();
      chodNa(x,y); 
    }
    if (y == surY && x != surX) {
      otocSpravne();
      chodNa(x,y);
    }
    break; 
  case 'L':
    while (x < surX) {
      prejdiKrizovatku();
      hladajKrizovatku();
    } 
    if (y < surY){
      odbocVlavo();
      chodNa(x,y); 
    } 
    else if (y > surY) {
      odbocVpravo();
      chodNa(x,y); 
    }
    if (y == surY && x != surX) {
      otocSpravne();
      chodNa(x,y);
    }
    break; 
  }
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////



//// FUNCTIONS

void ShiftOut(int Value, int BitsCount) {
  for(int i = BitsCount; i >= 0; i--) {
    digitalWrite(CLK_pin, LOW);
    if ((Value & 1 << i) == ( 1 << i)) {
      digitalWrite(DIO_pin, HIGH);
    }
    else {
      digitalWrite(DIO_pin, LOW);
    }
    digitalWrite(CLK_pin, HIGH);
    delayMicroseconds(1);
  }
}

int ShiftIn(int BitsCount) {
  int ShiftIn_result;
  ShiftIn_result = 0;
  pinMode(DIO_pin, INPUT);
  for(int i = BitsCount; i >= 0; i--) {
    digitalWrite(CLK_pin, HIGH);
    delayMicroseconds(1);
    if (digitalRead(DIO_pin) == HIGH) {
      ShiftIn_result = (ShiftIn_result << 1) + 1;
    }
    else {
      ShiftIn_result = (ShiftIn_result << 1) + 0;
    }
    digitalWrite(CLK_pin, LOW);
    delayMicroseconds(1);
  }
  if ((ShiftIn_result & 1 << 11) == 1 << 11) {
    ShiftIn_result = (B11111000 << 8) | ShiftIn_result;
  }
  return ShiftIn_result;
}

void HM55B_Reset() {
  pinMode(DIO_pin, OUTPUT);
  digitalWrite(EN_pin, LOW);
  ShiftOut(B0000, 3);
  digitalWrite(EN_pin, HIGH);
}

void HM55B_StartMeasurementCommand() {
  pinMode(DIO_pin, OUTPUT);
  digitalWrite(EN_pin, LOW);
  ShiftOut(B1000, 3);
  digitalWrite(EN_pin, HIGH);
}

int HM55B_ReadCommand() {
  int result = 0;
  pinMode(DIO_pin, OUTPUT);
  digitalWrite(EN_pin, LOW);
  ShiftOut(B1100, 3);
  result = ShiftIn(3);
  return result;
}

int compass(){
  HM55B_StartMeasurementCommand(); // necessary!!
  delay(30); // the data is 40ms later ready
  HM55B_ReadCommand(); // read data and print Status
  int X_Data = ShiftIn(11); // Field strength in X
  int Y_Data = ShiftIn(11); // and Y direction
  digitalWrite(EN_pin, HIGH); // ok deselect chip
  int result = 180 * (atan2(-1 * Y_Data , X_Data) / M_PI);
  return  result;// angle is atan( -y/x) !!!
}

















